// AmphibVhcl.c -- Amphibious Vehicle

#include "AmphibVh.h"
#include <nihclIO.h>

#define THIS    AmphibVhcl
#define BASE_CLASSES LandVhcl::desc(),WaterVhcl::desc()
#define MEMBER_CLASSES
#define VIRTUAL_BASE_CLASSES

DEFINE_CLASS_MI(AmphibVhcl,1,"$"__FILE__" "__DATE__" "__TIME__"$",NULL);

#ifdef __BCPLUSPLUS__
AmphibVhcl::AmphibVhcl(const AmphibVhcl& copyfrom) :
	Vehicle(copyfrom), LandVhcl(copyfrom), WaterVhcl(copyfrom)
{
}
#endif

void* AmphibVhcl::_castdown(const Class& target) const
{
    if (&target == desc()) return (void*)this;
    void* p = LandVhcl::_castdown(target);
    void* q = p;
	 if ((p = WaterVhcl::_castdown(target)) != NULL )    // MFM
		ambigCheck(p,q,target);
    return q;
}

void AmphibVhcl::_printOn(ostream& strm) const
{
    LandVhcl::_printOn(strm);
    WaterVhcl::_printOn(strm);
}

void AmphibVhcl::deepenShallowCopy()
{
    LandVhcl::deepenShallowCopy();
    WaterVhcl::deepenShallowCopy();
}

AmphibVhcl::AmphibVhcl(OIOin& strm) :
    Object(strm),
    Vehicle(strm),
    LandVhcl(strm),
    WaterVhcl(strm)
{
}

void AmphibVhcl::storer(OIOout& strm) const
{
    Vehicle::storeVBaseOn(strm);
    LandVhcl::storer(strm);
    WaterVhcl::storer(strm);
}

AmphibVhcl::AmphibVhcl(OIOifd& fd) :
    Object(fd),
    Vehicle(fd),
    LandVhcl(fd),
    WaterVhcl(fd)
{
}

void AmphibVhcl::storer(OIOofd& fd) const
{
    Vehicle::storeVBaseOn(fd);
    LandVhcl::storer(fd);
    WaterVhcl::storer(fd);
}
