#ifndef	IDENTDICT_H
#define	IDENTDICT_H
 
/* MS-DOS version of NIH class library - Michael F. Murphy 4/93 */
/* Unix source:  */ 
/* IdentDict.h,v 3.11 92/07/26 14:32:26 */

#include "nihclstd.h"
#pragma hdrstop

#include "Dictiona.h"

class LookupKey;

class IdentDict: public Dictionary {
	DECLARE_MEMBERS(IdentDict);
protected:
	virtual	int findIndexOf(const Object&) const;	// search method
	virtual	unsigned long hashOf(const Object&) const;	// hash method
protected:		// storer() functions for object I/O
	virtual	void storer(OIOofd& fd)	const	{ Dictionary::storer(fd); };
	virtual	void storer(OIOout& strm) const	{ Dictionary::storer(strm); };
public:
	IdentDict(unsigned size =DEFAULT_CAPACITY);
	IdentDict(const IdentDict&);
	virtual LookupKey* assocAt(const Object& key) const;
	virtual Object* atKey(const Object& key) const;
	virtual Object* atKey(const Object& key, Object& newValue);
	virtual bool includesKey(const Object& key) const;
};

#endif
