#ifndef KEYSORTCLTNH
#define KEYSORTCLTNH
                  
 /* MS-DOS version of NIH class library - Michael F. Murphy 4/93 */
/* Unix source:  KeySortCltn.h 3.11  92/07/26  14:32:34 */                 

#include "nihclstd.h"
#pragma hdrstop

#include "SortedCl.h"
#include "LookupKe.h"

class Assoc;

class KeySortCltn: public SortedCltn {
	DECLARE_MEMBERS(KeySortCltn);
protected:     // storer() functions for object I/O
	virtual  void storer(OIOofd& fd) const { SortedCltn::storer(fd); };
	virtual  void storer(OIOout& strm) const  { SortedCltn::storer(strm); };
public:
	KeySortCltn(int size =DEFAULT_CAPACITY);
	KeySortCltn(const KeySortCltn&);                    
	
	virtual LookupKey* assocAt(int i);
	virtual Object* keyAt(int i);
	virtual Object* valueAt(int i);
	virtual Object* atKey(Object& key);

	virtual Assoc* addAssoc(Object& key,Object& val);
	virtual Collection& addValuesTo(Collection&) const;
	virtual Collection& addKeysTo(Collection&) const;
	virtual Collection& addContentsBeforeTo(Object&,Collection&);
};

#endif
