#ifndef	FLOAT_H
#define	FLOAT_H
                 
/* MS-DOS version of NIH class library - Michael F. Murphy 4/93 */
/* Unix source:  */                 
/* Float.h,v 3.11 92/07/26 14:32:19 */

#include "nihclstd.h"
#pragma hdrstop


class Float: public VIRTUAL Object {
	DECLARE_MEMBERS(Float);
	double val;
	void parseFloat(istream& strm)	{ strm >> val; }
protected:		// storer() functions for object I/O
	virtual void storer(OIOofd&) const;
	virtual void storer(OIOout&) const;
public:
	Float(double v =0)		{ val = v; }
#if defined(MIBADDEFAULTFCNS)
	Float(const Float& copyfrom);
	Float& operator=(const Float& rhs);
#endif
	Float(istream&);
	double value() const		{ return val; }
	double value(double newval)	{ return val = newval; }
	virtual int compare(const Object&) const;
	virtual void	deepenShallowCopy();	// {}
	virtual unsigned long hash() const;
	virtual bool isEqual(const Object&) const;
	virtual void printOn(ostream& strm =cout) const;
	virtual void scanFrom(istream& strm);
	virtual const Class* species() const;
};

#endif
