#ifndef	RANGE_H
#define	RANGE_H

/* MS-DOS version of NIH class library - Michael F. Murphy 4/93 */
/* Unix source:  */
/* Range.h,v 3.11 92/07/26 14:33:29 */

#include "nihclstd.h"
#pragma hdrstop


class Range: public VIRTUAL Object {
	DECLARE_MEMBERS(Range);
	int first,len;
protected:		// storer() functions for object I/O
	virtual void storer(OIOofd&) const;
	virtual void storer(OIOout&) const;
public:
	Range()			{ first = 0; len = -1; }
	Range(int f, int l)	{ first = f; len = l; }
#if defined(MIBADDEFAULTFCNS)
	Range(const Range& copyfrom);
	Range& operator=(const Range& rhs);
#endif
	int length() const	{ return len; }
	int length(int l)	{ return len = l; }
	int firstIndex() const	{ return first; }
	int firstIndex(int f)	{ return first = f; }
	int lastIndex() const	{ return (first + len - 1); }
	int lastIndex(int i)	{ len = i - first + 1;  return i; }
	bool valid() const	{ return (len >= 0); }
	bool operator==(const Range& r) const { return ((first == r.first) && (len == r.len)); }
	bool operator!=(const Range& r)	const { return !(*this==r); }
	virtual void deepenShallowCopy();	// {}
	virtual unsigned long hash() const;
	virtual bool isEqual(const Object&) const;
	virtual void printOn(ostream& strm =cout) const;
	virtual const Class* species() const;
private:			    // shouldNotImplement()
	virtual int compare(const Object&) const;
};

#endif
