/* MSDOS revisions - Michael Murphy 1993
 * 8.3 filenames
 * generated .v file
 * main() return value
 */
#include "nihclstd.h"
#pragma hdrstop 
 
#include <SeqCltn.h>
#include <String.h>
#include <Set.h>
#include <OrderedC.h>

void same_contents_as(const Collection& c1, const Collection& c2)
{
    cout << "Collection::sameContentsAs: "
         << ((c1.sameContentsAs(c2))? "YES":"NO")
         << " "
         << ((c2.sameContentsAs(c1))? "YES":"NO")
         << endl; 
}
void same_contents_inorder_as(const SeqCltn& c1, const SeqCltn& c2)
{
    cout << "SeqCltn::sameContentsInOrderAs: "
         << ((c1.sameContentsInOrderAs(c2))? "YES":"NO")
         << " "
         << ((c2.sameContentsInOrderAs(c1))? "YES":"NO")
         << endl; 
}      

void main()
{
    OrderedCltn ocltn;
    Set scltn;
// test for empty collections
    same_contents_as(ocltn,scltn);

// test for different contents
    String* s1 = new String("string1");
    ocltn.add(*s1);
    same_contents_as(ocltn,scltn);

    String* s2 = new String("string2");    
    scltn.add(*s2);
    same_contents_as(ocltn,scltn);

    scltn.add(*s1);
    same_contents_as(ocltn,scltn);

// test for same contents
    ocltn.add(*s2);
    same_contents_as(ocltn,scltn);

    OrderedCltn o1, o2; 
// test for empty collections
    same_contents_inorder_as(o1,o2);

// test for different contents
    o1.add(*s1);
    same_contents_inorder_as(o1,o2);

    o2.add(*s1);
    same_contents_inorder_as(o1,o2);

    o1.add(*s2);
    same_contents_inorder_as(o1,o2);

// test for same contents
    o2.add(*s2);
    same_contents_inorder_as(o1,o2);

// test for different order
    Object* ob = o2.at(0);
    o2.at(0) = o2.at(1);
    o2.at(1) = ob;
	 same_contents_inorder_as(o1,o2);
	 return 0;
}
